/*
 * RandomAveraging.java
 *
 * Created on April 27, 2005, 4:54 PM
 */

package terrain;

/**
 *
 * @author Cliff
 */
public class RandomAveraging {
    public static int[][] RA(int aves, int xSize, int ySize) {
        int num_averages = aves;
        int[][] array = new int[xSize][ySize];
        
        //initialize the array to some random values
        for(int j = 0; j < ySize; j++) {
            for(int i = 0; i < xSize; i++) {
                array[i][j] = (int) ((Math.random())*256);
            }
        }
        
        for(int k = 0; k < num_averages; k++) {
            for(int j = 0; j < ySize; j++) {
                for(int i = 0; i < xSize; i++) {
                    array[i][j] =		array[i][j]
                            +	array[(i+255)%256][(j+255)%256]
                            +	array[(i+255)%256][(j)%256]
                            +	array[(i+255)%256][(j+1)%256]//left side
                            +	array[(i)%256][(j+255)%256]
                            +	array[(i)%256][(j+1)%256]//middle
                            +	array[(i+1)%256][(j+255)%256]
                            +	array[(i+1)%256][(j)%256]
                            +	array[(i+1)%256][(j+1)%256];//right side
                    
                    array[i][j] = array[i][j]/9;
                }
            }
        }
        return array;
    }
    
    public static void main(String[] args) {
        HeightMap.writeJPG(RA(12, 250, 250), "RandomAveraging"+12);
    }
}